#include <stdio.h>

__global__ void WriteIndex(int* a, int n)
{
    int i = threadIdx.x;
    if (i < n) {
        a[i] = i;
    }
}

int main()
{
    // Init
    int N = 16;
    int* h_a = new int[N]; // on host (CPU)
    int* d_a;              // on device (GPU)
    cudaMalloc(&d_a, N * sizeof(int));

    // Copy data from host to device
    // Do nothing

    // Main
    int blocks = 1;
    int threads_per_block = N;
    WriteIndex<<<blocks, threads_per_block>>>(d_a, N);
    
    // Copy data from device to host
    cudaMemcpy(h_a, d_a, N * sizeof(int), cudaMemcpyDeviceToHost);

    // Display results
    for (int i = 0; i < N; i++) {
        printf("%d\n",h_a[i]);
    }
    
    // Free memory
    delete [] h_a;
    cudaFree(d_a);
    
    return 0;
}

